<?php

namespace CreoCode\ContaoColumns\Component\ContentElement;
use Contao\PageModel;

class ColsStart extends \ContentElement
{

	/**
	 * Template
	 * @var string
	 */
	protected $strTemplate = 'ce_colsStart';

	/**
	 * Set-Type
	 */
	protected $strSet;

	/**
	 * Display a wildcard in the back end
	 * @return string
	 */
	public function generate() {

		if (TL_MODE == 'BE') {
            $this->Template = new \BackendTemplate('be_colsElement');
            $this->Template->setColor = '#'.$this->column_color;
            $this->Template->colsetTitle = $GLOBALS['TL_LANG']['MSC']['colsStart'];
            $this->Template->colsetSubtitle = '<span class="count">'.$GLOBALS['TL_LANG']['MSC']['cols'].': '.$this->column_amount.'</span> | <span class="name">'.$GLOBALS['TL_LANG']['MSC']['name'].': '.$this->column_name.'</span>';
            //$this->Template->visualSet = $strMiniset;
            $this->Template->hint = sprintf($GLOBALS['TL_LANG']['MSC']['contentAfter'],$GLOBALS['TL_LANG']['MSC']['column_first']);
            $this->Template->colsetParent = $this->column_parent;

            return $this->Template->parse();
		}

		return parent::generate();
	}

	/**
	 * Generate content element
	 * @return string
	 */
	protected function compile() {
        $columns = $this->column_amount;

        // Gap
        $gapArray = '';
		if($this->column_usecustomgap == 1 && $this->column_gap) {
            $gapArray = unserialize($this->column_gap);
            $containermarginhorizontal = $this->column_containermarginhorizontal;
            $containermarginvertical = $this->column_containermarginvertical;
        } else {
            $rootPage = PageModel::findByPk($GLOBALS['objPage']->rootId);
            if($rootPage->column_usegap == 1 && $rootPage->column_gap) {
                $gapArray = unserialize($rootPage->column_gap);
                $containermarginhorizontal = $rootPage->column_containermarginhorizontal;
                $containermarginvertical = $rootPage->column_containermarginvertical;
            }
        }
        $this->Template->gap_col = '';
        $this->Template->gap_row = '';
        if ($gapArray) {
            foreach ($gapArray as $key => $gap) {
                if ($key !== 'unit') {
                    $this->Template->gap_col .= 'padding-'.$key.':'.$gap.$gapArray['unit'].';';
                    if ($containermarginhorizontal) {
                        if ($key === 'left' || $key === 'right') {
                            $this->Template->gap_row .= 'margin-'.$key.':-'.$gap.$gapArray['unit'].';';
                        }
                    }
                    if ($containermarginvertical) {
                        if ($key === 'top' || $key === 'bottom') {
                            $this->Template->gap_row .= 'margin-'.$key.':-'.$gap.$gapArray['unit'].';';
                        }
                    }
                }
            }
        }


        $colClasses = '';
        $colSizes = [];
        if (isset($this->column_sizes)) {
            $colSizes = unserialize($this->column_sizes);
        }
        foreach ($colSizes as $size) {
            $colSetSizeArray = unserialize($this->{'columns_'.$size});
            if ($colSetSizeArray[0]['width'] === 'auto') {
                $colClasses .= ' col-' . $size;
            } else {
                $colClasses .= ' col-' . $size . '-' . $colSetSizeArray[0]['width'];
            }

            if ($colSetSizeArray[0]['offset'] != NULL) {
                $colClasses .= ' col-' . $size . '-offset-' . $colSetSizeArray[0]['offset'];
            }
            if ($colSetSizeArray[0]['order'] != NULL) {
                $colClasses .= ' col-' . $size . '-order-' . $colSetSizeArray[0]['order'];
            }
            if ($colSetSizeArray[0]['align'] != NULL) {
                $colClasses .= ' col-' . $size . '-align-' . $colSetSizeArray[0]['align'];
            }
        }

        if (unserialize($this->column_expert)[0]['cssClass'] != NULL) {
            $colClasses .= ' ' . unserialize($this->column_expert)[0]['cssClass'];
        }

        $this->Template->scclass = $GLOBALS['TL_SUBCL'][$this->strSet]['scclass'] . 'columns_' . $columns;
        $this->Template->rowClass = '';

        // justify & align
        if ($this->column_justify) {
            $this->Template->rowClass .= ' justify-'.$this->column_justify;
        }
        if ($this->column_align) {
            $this->Template->rowClass .= ' align-'.$this->column_align;
        }

		$this->Template->column = 'ce_colsPart' . ' col_1' . $colClasses . ' first';
	}

}
